//+------------------------------------------------------------------+
//|                                                        Vidya.mq4 |
//|                                                                  |
//| Vidya developed by Tushar Chande                                 |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property  indicator_chart_window
#property  indicator_buffers 3
#property  indicator_color1  DeepSkyBlue
#property  indicator_color2  DimGray
#property  indicator_color3  DarkOrange
#property  indicator_width1  2
#property  indicator_width3  2
#property  indicator_style2  STYLE_DOT

//
//
//
//
//

extern int CmoPeriod1    = 25;
extern int SmoothPeriod1 =  9;
extern int Price1        = PRICE_HIGH;
extern int CmoPeriod2    = 25;
extern int SmoothPeriod2 =  9;
extern int Price2        = PRICE_MEDIAN;
extern int CmoPeriod3    = 25;
extern int SmoothPeriod3 =  9;
extern int Price3        = PRICE_LOW;

//
//
//
//
//

double vidya1[];
double vidya2[];
double vidya3[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,vidya1);
   SetIndexBuffer(1,vidya2);
   SetIndexBuffer(2,vidya3);
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
   int i,limit;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
   
   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--) 
   {
      if (CmoPeriod1>0) vidya1[i] = iVidya(iMA(NULL,0,1,0,MODE_SMA,Price1,i),CmoPeriod1,SmoothPeriod1,0,i);
      if (CmoPeriod2>0) vidya2[i] = iVidya(iMA(NULL,0,1,0,MODE_SMA,Price2,i),CmoPeriod2,SmoothPeriod2,1,i);
      if (CmoPeriod3>0) vidya3[i] = iVidya(iMA(NULL,0,1,0,MODE_SMA,Price3,i),CmoPeriod3,SmoothPeriod3,2,i);
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double  vidya_work[][6];
#define vidya_price 0
#define vidya_value 1

//
//
//
//
//

double iVidya(double price, int cmoPeriods, int smoothPeriods, int forCalculation, int i)
{
   if (ArrayRange(vidya_work,0)!=Bars) ArrayResize(vidya_work,Bars);
   
   int r = Bars-i-1;
   int s = forCalculation*2;
      double alpha = 2.00/(1.00+smoothPeriods);
   
      //
      //
      //
      //
      //
      
         vidya_work[r][s+vidya_price] = price;
         
               double sumUp  = 0;
               double sumDo  = 0;
               for (int j=0; j < cmoPeriods; j++)
               {
                  double diff = vidya_work[r-j][s+vidya_price]-vidya_work[r-j-1][s+vidya_price];
                  if (diff > 0)
                        sumUp += diff;
                  else  sumDo -= diff;
               }      
               double k = 1; if ((sumUp+sumDo)!=0) k = MathAbs((sumUp-sumDo)/(sumUp+sumDo));
      
          vidya_work[r][s+vidya_value] = k*alpha*vidya_work[r][s+vidya_price] + (1-k*alpha)*vidya_work[r-1][s+vidya_value];
          
      //
      //
      //
      //
      //
                
   return(vidya_work[r][s+vidya_value]);
}